//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%383EF9AC4B08.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%383EF9AC4B08.cm

//## begin module%383EF9AC4B08.cp preserve=no
//## end module%383EF9AC4B08.cp

//## Module: TclStream%383EF9AC4B08; Package body
//## Subsystem: XSUser::UserInterface%3804B6846530
//	/local/data/verisB/dorman/Xspec/src/userint
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSUser/UserInterface/TclStream.cxx

//## begin module%383EF9AC4B08.additionalIncludes preserve=no
//## end module%383EF9AC4B08.additionalIncludes

//## begin module%383EF9AC4B08.includes preserve=yes
//## end module%383EF9AC4B08.includes

// TclStream
#include <TclStream.h>
//## begin module%383EF9AC4B08.declarations preserve=yes
// xstcl
#include "xstcl.h"
//## end module%383EF9AC4B08.declarations

//## begin module%383EF9AC4B08.additionalDeclarations preserve=yes
#include <XSUser/Global/Global.h>
#include <XSUser/Global/XSGlobal.h>
#include <XSUtil/Utils/IosHolder.h>
#include "XSstreams.h"
#include "XSContainer.h"
#include <sstream>
#include <cstring>
//Tcl_ChannelType* xstcl::xsLogPtr = 0;
//## end module%383EF9AC4B08.additionalDeclarations


// Class TclIO 

TclIO::TclIO(const TclIO &right)
  //## begin TclIO::TclIO%3898891AB9A8_copy.hasinit preserve=yes
      : m_ioChannel(right.m_ioChannel),
        m_logChannel(right.m_logChannel),
        m_prompt(right.m_prompt)
  //## end TclIO::TclIO%3898891AB9A8_copy.hasinit
  //## begin TclIO::TclIO%3898891AB9A8_copy.initialization preserve=yes
  //## end TclIO::TclIO%3898891AB9A8_copy.initialization
{
  //## begin TclIO::TclIO%3898891AB9A8_copy.body preserve=yes
  //## end TclIO::TclIO%3898891AB9A8_copy.body
}

TclIO::TclIO (Tcl_Channel channel)
  //## begin TclIO::TclIO%38AC59128390.hasinit preserve=no
      : m_ioChannel(channel),
        m_logChannel(0)
  //## end TclIO::TclIO%38AC59128390.hasinit
  //## begin TclIO::TclIO%38AC59128390.initialization preserve=yes
  //## end TclIO::TclIO%38AC59128390.initialization
{
  //## begin TclIO::TclIO%38AC59128390.body preserve=yes
  //workaround for tcl8.4.4 bug: ensure that channel has linefeed not crlf
  Tcl_SetChannelOption(0,channel,"-translation","auto lf");
  //## end TclIO::TclIO%38AC59128390.body
}


TclIO::~TclIO()
{
  //## begin TclIO::~TclIO%3898891AB9A8_dest.body preserve=yes
  //## end TclIO::~TclIO%3898891AB9A8_dest.body
}



//## Other Operations (implementation)
std::streamsize TclIO::read (char* s, std::streamsize n)
{
  //## begin TclIO::read%38A97E5A1E78.body preserve=yes
 
  
 // reimplemented 8/2003 using tclreadline module.
 // Call "tclreadline::readline read" with prompt " "
 // Based on code by Micah Johnson written for ximage, used with thanks. 8/27/03


  Tcl_Obj* cmdList (Tcl_NewObj());
  Tcl_Obj* tmpObj  (Tcl_NewStringObj("tclreadline::readline", -1));
  Tcl_ListObjAppendElement(interp, cmdList, tmpObj);
  
  tmpObj = Tcl_NewStringObj("read", -1);
  Tcl_ListObjAppendElement(interp, cmdList, tmpObj);
  
  tmpObj = Tcl_NewStringObj(m_prompt.c_str(), -1);
  Tcl_ListObjAppendElement(interp, cmdList, tmpObj);
  
  Tcl_EvalObjEx(interp, cmdList, TCL_EVAL_GLOBAL);
  Tcl_Obj* resObj (Tcl_GetObjResult(interp));
  Tcl_SetVar(interp, xstcl::xs_tcl_prompt, IosHolder::xsPrompt(),TCL_GLOBAL_ONLY);
  
  
  int mc (-1);
  std::streamsize chars (0);
  const char* TCLGET (Tcl_GetStringFromObj(resObj,&mc));

  if ( mc >= 0 )
  {
      chars = std::min(static_cast<std::streamsize>(mc),n-1);
      memcpy(s,TCLGET,chars);
      memset(s+chars,'\n',1);          
  }
  
  // test writing user input to log channel.
  if (m_logChannel)
  {
         static const char nl[] = "\n";
         string bangPrompt("!" + m_prompt);
         Tcl_Write(m_logChannel,bangPrompt.c_str(),-1);
         Tcl_Write(m_logChannel,TCLGET,-1);
         Tcl_Write(m_logChannel,nl,-1);
  }
  Tcl_ResetResult(interp);
   
  return chars + 1;
  //## end TclIO::read%38A97E5A1E78.body
}

std::streamsize TclIO::write (const char* s, std::streamsize n)
{
  //## begin TclIO::write%38A97E9A3220.body preserve=yes
  // require some handling here to catch the case where
  // output unsuccessful (nchars != n);
 std::streamsize nchars(n);
 int conTrivia = stream()->conVerbose();
 int logTrivia = stream()->logVerbose();
 
 // conTrivia is a measure of the "unimportance" of the string to
 // be written for console, and logTrivia for logging channel. This should
 // emulate the behavior of xwrite in xspec11.
 // strings are written to the channels whenever the string is 'less trivial'
 // than the chatter setting: so when the chatter setting is high, nothing
 // is trivial.
 
 // to make an output appear only for high chatter levels, raise its
 // triviality by using the XSstream::verbose call.
  
 
  if (conTrivia && (conTrivia <= stream()->consoleChatterLevel()) )      
  {      
        nchars = Tcl_WriteChars(ioChannel(),const_cast<char *>(s),n);
        Tcl_Flush(ioChannel());
  }
  if (logTrivia && logChannel() && XSGlobal::globalData->logging() 
       && logTrivia  <= stream()->logChatterLevel())
  {
        string ss(s,n);
        int nlPos = ss.find_first_of('\n');
        int nHash(0);
        while (nlPos >= 0)
        {
                ss = ss.insert(++nlPos,"#");
                ++nHash;
                nlPos = ss.find_first_of('\n',nlPos);       
        } 
//        if ( ss[ss.length()-1] == '#' )
//        {
//                ss += string("\n");
//                ++nHash;
//        }
        nlPos = Tcl_WriteChars(logChannel(),const_cast<char *>(ss.data()),n+nHash);
        //nchars = Tcl_WriteChars(logChannel(),s,n);
        Tcl_Flush(logChannel());
  }
  //## end TclIO::write%38A97E9A3220.body

  return nchars;
}

void TclIO::internalSetLogger (const std::string& name, bool isErr)
{
  //## begin TclIO::internalSetLogger%3B966EE402AD.body preserve=yes
  using namespace xstcl;
  static char bfg[] = "-buffering";
  static char ln[] = "line";

  if (!isErr)
  {
     /*
      * Open the log file and register it.
      */

     char* lf = const_cast<char*>(name.c_str());

     char w[] = "w"; 
     if( (m_logChannel = Tcl_OpenFileChannel(interp, lf, w, 0664) )== 0 ) 
     {
             throw LogFileOpenFailure(name);
     }
     else
     {
           // the global symbol XS_Logfile_Chan is used in xsOutput.
           XS_Logfile_Chan = m_logChannel;
           // the need to register this is unclear, since tcl doesn't ever
           // directly write to the open file channel - it writes to
           // the logging channels through xsOutputLog which writes
           // to this file channel. Not the same thing.
           // Tcl_RegisterChannel(interp,m_logChannel);     
     }
     /*
     * Create the channel getting input from gnu readline.
     * Updated B.Dorman. 11/98 for compatibility with tcl8.0 
     *
     * Channel drivers revised in tcl8.3.2 8/2000.
     *
     */
     xsLogPtr = new Tcl_ChannelType;
     char typeN[] = "file";
     xsLogPtr->typeName = typeN;
     xsLogPtr->version  = (Tcl_ChannelTypeVersion) TCL_CHANNEL_VERSION_2;
     xsLogPtr->closeProc = (Tcl_DriverCloseProc *)xsCloseLog;
     xsLogPtr->inputProc = (Tcl_DriverInputProc *)xsInputLog;
     xsLogPtr->outputProc = (Tcl_DriverOutputProc *)xsOutputLog;
     xsLogPtr->seekProc = (Tcl_DriverSeekProc *)NULL;
     xsLogPtr->setOptionProc = (Tcl_DriverSetOptionProc *)NULL;
     xsLogPtr->getOptionProc = (Tcl_DriverGetOptionProc *)NULL;
     xsLogPtr->watchProc = (Tcl_DriverWatchProc *)xsWatchLog;
     xsLogPtr->getHandleProc = (Tcl_DriverGetHandleProc *)xsHandleLog;
     xsLogPtr->close2Proc = (Tcl_DriverClose2Proc *)NULL;                
     xsLogPtr->blockModeProc = (Tcl_DriverBlockModeProc *)NULL;
     xsLogPtr->flushProc     = (Tcl_DriverFlushProc *)NULL;
     xsLogPtr->handlerProc     = (Tcl_DriverHandlerProc *)NULL;


     Tcl_Channel 
          Logging_Chan(Tcl_CreateChannel( xsLogPtr, xsLogOut,  (ClientData)xsLogOut, TCL_WRITABLE));

     Tcl_SetVar(interp,"logchan",xsLogOut,TCL_GLOBAL_ONLY);
     Tcl_RegisterChannel(interp, Logging_Chan);

     if ( Tcl_SetChannelOption(interp, Logging_Chan, bfg, ln) != TCL_OK ) 
             throw LogFileOpenFailure(string(" setting channel options "));


     /*
      * Now switch it around to be the standard channel for output,
      * after saving the value of the old channel so we can restore it.
      */
     XS_Stdout_Chan = Tcl_GetStdChannel(TCL_STDOUT);

     Tcl_SetStdChannel(Logging_Chan, TCL_STDOUT);

     /*
      * Now do the same for the standard error
      */

     Logging_Chan = Tcl_CreateChannel( xsLogPtr, xsLogErr,(ClientData)xsLogErr, TCL_WRITABLE);

     Tcl_RegisterChannel(interp, Logging_Chan);

     // check- stderr is not buffered
     if ( Tcl_SetChannelOption(interp, Logging_Chan, bfg, ln) != TCL_OK ) 
             throw LogFileOpenFailure(string(" setting channel options "));

     //assert( Tcl_SetChannelOption(xsInterp, Logging_Chan, bfg, ln) == TCL_OK );

     XS_Stderr_Chan = Tcl_GetStdChannel(TCL_STDERR);

     Tcl_SetStdChannel(Logging_Chan, TCL_STDERR);

     Tcl_AppendResult(interp, "\nLogging to file: ", lf, (char *)NULL);
  }
  else
  {
     TclIO* tpoutChan = dynamic_cast<TclIO*>(tpout.getChannel());
     if (tpoutChan)
     {
        m_logChannel = tpoutChan->m_logChannel;
     }
  }
  //## end TclIO::internalSetLogger%3B966EE402AD.body
}

void TclIO::internalCloseLog ()
{
  //## begin TclIO::internalCloseLog%3B968E6601A1.body preserve=yes
   using namespace xstcl;
   //ask tcl whether there is a log file open.
   static char notActive[] = "log file is not open";
   static char disabled[] = "logging switched off";   
   if( m_logChannel == 0 )
   {
           Tcl_SetResult(interp,notActive, TCL_VOLATILE);
   }
   else
   {
           // Tcl_UnregisterChannel(interp, m_logChannel);
           // also unregister stderr's direction to log file
           Tcl_Channel Logging_Chan(Tcl_GetChannel(interp, xsLogErr, 0));
           Tcl_UnregisterChannel(interp, Logging_Chan);
           Logging_Chan = Tcl_GetChannel(interp, xsLogOut, 0);
           Tcl_UnregisterChannel(interp, Logging_Chan);
           Tcl_SetResult(interp,disabled, TCL_VOLATILE);
           Tcl_SetStdChannel(XS_Stdout_Chan, TCL_STDOUT);
           Tcl_SetStdChannel(XS_Stderr_Chan, TCL_STDERR);
           Tcl_UnsetVar(interp,"logchan",TCL_GLOBAL_ONLY);
           XSGlobal::globalData->logging(false);
           delete xsLogPtr;
           xsLogPtr = 0;   
   } 
   TclIO* tperrChan = dynamic_cast<TclIO*>(tperr.getChannel());
   if (tperrChan)
   {
      tperrChan->m_logChannel = 0;
   }
    
  //## end TclIO::internalCloseLog%3B968E6601A1.body
}

void TclIO::setPrompt (const string& ps)
{
  //## begin TclIO::setPrompt%3F4D122502A3.body preserve=yes
  m_prompt = ps;
  //## end TclIO::setPrompt%3F4D122502A3.body
}

// Additional Declarations
  //## begin TclIO%3898891AB9A8.declarations preserve=yes
  //## end TclIO%3898891AB9A8.declarations

// Class TkIO 

TkIO::TkIO(const TkIO &right)
  //## begin TkIO::TkIO%389888DF2238_copy.hasinit preserve=yes
      : m_window(right.m_window),
        m_logChannel(right.m_logChannel)
  //## end TkIO::TkIO%389888DF2238_copy.hasinit
  //## begin TkIO::TkIO%389888DF2238_copy.initialization preserve=yes
  //## end TkIO::TkIO%389888DF2238_copy.initialization
{
  //## begin TkIO::TkIO%389888DF2238_copy.body preserve=yes

        
  // I don't really think we should need a copy constructor anyway.
              
  //## end TkIO::TkIO%389888DF2238_copy.body
}

TkIO::TkIO (char* winName)
  //## begin TkIO::TkIO%38AC58862880.hasinit preserve=no
      : m_window(winName),
        m_logChannel(0)
  //## end TkIO::TkIO%38AC58862880.hasinit
  //## begin TkIO::TkIO%38AC58862880.initialization preserve=yes
  //## end TkIO::TkIO%38AC58862880.initialization
{
  //## begin TkIO::TkIO%38AC58862880.body preserve=yes
  //## end TkIO::TkIO%38AC58862880.body
}


TkIO::~TkIO()
{
  //## begin TkIO::~TkIO%389888DF2238_dest.body preserve=yes
  //## end TkIO::~TkIO%389888DF2238_dest.body
}



//## Other Operations (implementation)
std::streamsize TkIO::read (char* s, std::streamsize n)
{
  //## begin TkIO::read%38A97DBCC150.body preserve=yes
  // note that s is  a pointer to the streambuf
  // internal buffer, and n is the size of that buffer.
  // prompt() is a string that contains either
    
  // a) a prompt string
  // b) a command that returns a string back to the stream.

  // prompt has a default set by the tk procedure.
  // BY CONVENTION in this code, a prompt string ends in ":" or ">".

  static char tkGet[] = "XSgetbox ";
  const size_t MAXCHAR = 256;
  static char* charPrompt = new char[MAXCHAR+1];
  
  charPrompt[MAXCHAR] = 0;
  int lastNonBlank = 0;
  int findZero = 0;
  if (prompt().length() > 0)
  {
        lastNonBlank = prompt().find_last_not_of(' ');
        if (  strchr(":>",m_prompt[lastNonBlank]) != 0 )
        {
       // The prompt string  ends in ':' or ">",
       // so it's a string literal prompt. add it to the "XSgetbox" command.
	        strncpy(charPrompt,tkGet,MAXCHAR);
                if ((strlen(charPrompt)+prompt().length()) <=MAXCHAR)
	           strcat(charPrompt,prompt().c_str());
        }
        // it's a script name with arguments.
        else 
           strncpy(charPrompt,prompt().c_str(),MAXCHAR);
  }
  else 
  {
        findZero = -1;
        strncpy(charPrompt,tkGet,MAXCHAR); 
  } 
  
 
  int status = Tcl_Eval(interp,charPrompt);
  if (!status)
  {
        strcpy(s,Tcl_GetStringResult(interp));   
	strcat(s,"\n");
        return strlen(s);
  }
  else return -1;
  //## end TkIO::read%38A97DBCC150.body
}

std::streamsize TkIO::write (const char* s, std::streamsize n)
{
  //## begin TkIO::write%38A97DFC7FF0.body preserve=yes
  static char insert[] = " insert end {" ;
  static char end[] = "} \n";
  static char see[] = " see end\n";
  unsigned int nw = strlen(m_window);
  unsigned int lenStr = nw + n + 16;
  char* outStr = new char[lenStr+1];
  memcpy(outStr,m_window,nw);
  memcpy(outStr+nw,insert,13);
  memcpy(outStr+nw + 13,s,n);
  memcpy(outStr+nw + 13 + n,end,3);
  outStr[lenStr] = '\0';
  Tcl_EvalEx(interp,outStr,lenStr+1,0);
  strcat(strcpy(outStr,m_window),see); 
  Tcl_EvalEx(interp,outStr,strlen(outStr) + 1,0);
  delete [] outStr;
  //## end TkIO::write%38A97DFC7FF0.body

  return n;
}

void TkIO::setPrompt (const std::string& ps)
{
  //## begin TkIO::setPrompt%38D2B2BA3758.body preserve=yes
  m_prompt = ps;
  //## end TkIO::setPrompt%38D2B2BA3758.body
}

void TkIO::prompts (const std::string& script, const std::vector<std::string>& prompts, const std::vector<std::string>& infos)
{
  //## begin TkIO::prompts%38E273034F20.body preserve=yes
  //## end TkIO::prompts%38E273034F20.body
}

void TkIO::internalSetLogger (const std::string& name, bool isErr)
{
  //## begin TkIO::internalSetLogger%3B966F04030B.body preserve=yes
  using namespace xstcl;
  static char bfg[] = "-buffering";
  static char ln[] = "line";

  /*
   * Open the log file and register it.
   */

  char* lf = const_cast<char*>(name.c_str());

  char w[] = "w"; 
  if( (m_logChannel = Tcl_OpenFileChannel(interp, lf, w, 0664) )== 0 ) 
  {
          throw LogFileOpenFailure(name);
  }
  else
  {
        // the global symbol XS_Logfile_Chan is used in xsOutput.
        XS_Logfile_Chan = m_logChannel;
        // the need to register this is unclear, since tcl doesn't ever
        // directly write to the open file channel - it writes to
        // the logging channels through xsOutputLog which writes
        // to this file channel. Not the same thing.
        // Tcl_RegisterChannel(interp,m_logChannel);     
  }
  /*
  * Create the channel getting input from gnu readline.
  * Updated B.Dorman. 11/98 for compatibility with tcl8.0 
  *
  * Channel drivers revised in tcl8.3.2 8/2000.
  *
  */
  xsLogPtr = new Tcl_ChannelType;
  char typeN[] = "file";
  xsLogPtr->typeName = typeN;
  xsLogPtr->version  = (Tcl_ChannelTypeVersion) TCL_CHANNEL_VERSION_2;
  xsLogPtr->closeProc = (Tcl_DriverCloseProc *)xsCloseLog;
  xsLogPtr->inputProc = (Tcl_DriverInputProc *)xsInputLog;
  xsLogPtr->outputProc = (Tcl_DriverOutputProc *)xsOutputLog;
  xsLogPtr->seekProc = (Tcl_DriverSeekProc *)NULL;
  xsLogPtr->setOptionProc = (Tcl_DriverSetOptionProc *)NULL;
  xsLogPtr->getOptionProc = (Tcl_DriverGetOptionProc *)NULL;
  xsLogPtr->watchProc = (Tcl_DriverWatchProc *)xsWatchLog;
  xsLogPtr->getHandleProc = (Tcl_DriverGetHandleProc *)xsHandleLog;
  xsLogPtr->close2Proc = (Tcl_DriverClose2Proc *)NULL;                
  xsLogPtr->blockModeProc = (Tcl_DriverBlockModeProc *)NULL;
  xsLogPtr->flushProc     = (Tcl_DriverFlushProc *)NULL;
  xsLogPtr->handlerProc     = (Tcl_DriverHandlerProc *)NULL;


  Tcl_Channel 
       Logging_Chan(Tcl_CreateChannel( xsLogPtr, xsLogOut,  (ClientData)xsLogOut, TCL_WRITABLE));

  Tcl_RegisterChannel(interp, Logging_Chan);

  if ( Tcl_SetChannelOption(interp, Logging_Chan, bfg, ln) != TCL_OK ) 
          throw LogFileOpenFailure(string(" setting channel options "));

   
  /*
   * Now switch it around to be the standard channel for output,
   * after saving the value of the old channel so we can restore it.
   */
  XS_Stdout_Chan = Tcl_GetStdChannel(TCL_STDOUT);

  Tcl_SetStdChannel(Logging_Chan, TCL_STDOUT);

  /*
   * Now do the same for the standard error
   */

  Logging_Chan = Tcl_CreateChannel( xsLogPtr, xsLogErr,(ClientData)xsLogErr, TCL_WRITABLE);

  Tcl_RegisterChannel(interp, Logging_Chan);
  
  // check- stderr is not buffered
  if ( Tcl_SetChannelOption(interp, Logging_Chan, bfg, ln) != TCL_OK ) 
          throw LogFileOpenFailure(string(" setting channel options "));

  //assert( Tcl_SetChannelOption(xsInterp, Logging_Chan, bfg, ln) == TCL_OK );

  XS_Stderr_Chan = Tcl_GetStdChannel(TCL_STDERR);

  Tcl_SetStdChannel(Logging_Chan, TCL_STDERR);

  Tcl_AppendResult(interp, "\nLogging to file: ", lf, (char *)NULL);


  //## end TkIO::internalSetLogger%3B966F04030B.body
}

void TkIO::internalCloseLog ()
{
  //## begin TkIO::internalCloseLog%3B968E700285.body preserve=yes
   using namespace xstcl;
   //ask tcl whether there is a log file open.
   static char notActive[] = "log file is not open";
   static char disabled[] = "logging switched off";   
   if( m_logChannel == 0 )
   {
           Tcl_SetResult(interp,notActive, TCL_VOLATILE);
   }
   else
   {
           // Tcl_UnregisterChannel(interp, m_logChannel);
           // also unregister stderr's direction to log file
           Tcl_Channel Logging_Chan(Tcl_GetChannel(interp, xsLogErr, 0));
           Tcl_UnregisterChannel(interp, Logging_Chan);
           Logging_Chan = Tcl_GetChannel(interp, xsLogOut, 0);
           Tcl_UnregisterChannel(interp, Logging_Chan);
           Tcl_SetResult(interp,disabled, TCL_VOLATILE);
           Tcl_SetStdChannel(XS_Stdout_Chan, TCL_STDOUT);
           Tcl_SetStdChannel(XS_Stderr_Chan, TCL_STDERR);
           XSGlobal::globalData->logging(false);
           delete xsLogPtr;
           xsLogPtr = 0;
   }    
  //## end TkIO::internalCloseLog%3B968E700285.body
}

// Additional Declarations
  //## begin TkIO%389888DF2238.declarations preserve=yes
  //## end TkIO%389888DF2238.declarations

//## begin module%383EF9AC4B08.epilog preserve=yes
//## end module%383EF9AC4B08.epilog
